diff --git a/libr/anal/p/anal_java.c b/libr/anal/p/anal_java.c
index 46f7e2bd006..af05c5eb3e3 100644
--- a/libr/anal/p/anal_java.c
+++ b/libr/anal/p/anal_java.c
@@ -509,7 +509,6 @@ static int analyze_from_code_buffer(RAnal *anal, RAnalFunction *fcn, ut64 addr,
 		actual_size += bb->size;
 	}
 	r_anal_fcn_set_size (NULL, fcn, state->bytes_consumed);
-	result = state->anal_ret_val;
 	r_list_free (nodes->cfg_node_addrs);
 	free (nodes);
 	//leak to avoid UAF is the easy solution otherwise a whole rewrite is needed
diff --git a/libr/asm/arch/arm/aarch64/aarch64-opc.c b/libr/asm/arch/arm/aarch64/aarch64-opc.c
index 7b6d76913f7..37405d88481 100644
--- a/libr/asm/arch/arm/aarch64/aarch64-opc.c
+++ b/libr/asm/arch/arm/aarch64/aarch64-opc.c
@@ -984,7 +984,7 @@ static int
 match_operands_qualifier (aarch64_inst *inst, bfd_boolean update_p)
 {
   int i, nops;
-  aarch64_opnd_qualifier_seq_t qualifiers;
+  aarch64_opnd_qualifier_seq_t qualifiers = {0};
 
   if (!aarch64_find_best_match (inst, inst->opcode->qualifiers_list, -1,
 			       qualifiers))
diff --git a/libr/bin/format/elf/elf.c b/libr/bin/format/elf/elf.c
index 73dcbb6dfd3..8894d032796 100644
--- a/libr/bin/format/elf/elf.c
+++ b/libr/bin/format/elf/elf.c
@@ -802,7 +802,7 @@ static Sdb *store_versioninfo_gnu_verdef(ELFOBJ *bin, Elf_(Shdr) *shdr, int sz)
 	if (shdr->sh_size < sizeof (Elf_(Verdef)) || shdr->sh_size < sizeof (Elf_(Verdaux))) {
 		return false;
 	}
-	Elf_(Verdef) *defs = calloc (shdr->sh_size, sizeof (char));
+	Elf_(Verdef) *defs = calloc (shdr->sh_size, 1);
 	if (!defs) {
 		bprintf ("Cannot allocate memory (Check Elf_(Verdef))\n");
 		return false;
@@ -2590,7 +2590,7 @@ static RBinElfSection *get_sections_from_phdr(ELFOBJ *bin) {
 	int i, num_sections = 0;
 	ut64 reldyn = 0, relava = 0, pltgotva = 0, relva = 0;
 	ut64 reldynsz = 0, relasz = 0, pltgotsz = 0;
-	if (!bin || !bin->phdr || !bin->ehdr.e_phnum) {
+	if (!bin || !bin->phdr || !bin->ehdr.e_phnum || !bin->dyn_buf) {
 		return NULL;
 	}
 
diff --git a/libr/bin/format/mach0/mach0.c b/libr/bin/format/mach0/mach0.c
index 021192393fd..e75e35721a8 100644
--- a/libr/bin/format/mach0/mach0.c
+++ b/libr/bin/format/mach0/mach0.c
@@ -786,7 +786,6 @@ static bool parse_signature(struct MACH0_(obj_t) *bin, ut64 off) {
 					r_buf_read_at (bin->b, data + idx.offset + 0, p, length);
 					ut32 *words = (ut32*)p;
 					eprintf ("Magic: %x\n", words[0]);
-					words += 2;
 					eprintf ("wtf DUMP @%d!%d\n",
 						(int)data + idx.offset + 8, (int)length);
 					eprintf ("openssl pkcs7 -print_certs -text -inform der -in DUMP\n");
diff --git a/libr/core/cfile.c b/libr/core/cfile.c
index 632bb4eac45..d09617c2f5a 100644
--- a/libr/core/cfile.c
+++ b/libr/core/cfile.c
@@ -594,7 +594,9 @@ R_API bool r_core_bin_load(RCore *r, const char *filenameuri, ut64 baddr) {
 			}
 		}
 	} else {
-		r_io_map_new (r->io, desc->fd, desc->perm, 0, laddr, r_io_desc_size (desc));
+		if (desc) {
+			r_io_map_new (r->io, desc->fd, desc->perm, 0, laddr, r_io_desc_size (desc));
+		}
 		if (binfile) {
 			r_core_bin_set_arch_bits (r, binfile->file,
 					r_config_get (r->config, "asm.arch"),
diff --git a/libr/core/p/core_java.c b/libr/core/p/core_java.c
index c4122339cd9..9f6b9bc7552 100644
--- a/libr/core/p/core_java.c
+++ b/libr/core/p/core_java.c
@@ -1497,7 +1497,7 @@ static int r_cmd_java_call(void *user, const char *input) {
 		}
 	}
 	if (!res) {
-		res = r_cmd_java_handle_help (core, input);
+		return r_cmd_java_handle_help (core, input);
 	}
 	return true;
 }
@@ -1735,6 +1735,10 @@ static int r_cmd_java_set_acc_flags (RCore *core, ut64 addr, ut16 num_acc_flag)
 	//ut64 cur_offset = core->offset;
 	num_acc_flag = R_BIN_JAVA_USHORT (((ut8*) &num_acc_flag), 0);
 	res = r_core_write_at(core, addr, (const ut8 *)&num_acc_flag, 2);
+	if (!res) {
+		eprintf ("[X] r_cmd_java_set_acc_flags: Failed to write.\n");
+		return res;
+	}
 	//snprintf (cmd_buf, 50, fmt, num_acc_flag, addr);
 	//res = r_core_cmd0(core, cmd_buf);
 	res = true;
diff --git a/libr/core/visual.c b/libr/core/visual.c
index b9ae886de9a..28c48f5b233 100644
--- a/libr/core/visual.c
+++ b/libr/core/visual.c
@@ -3617,7 +3617,7 @@ R_API int r_core_visual(RCore *core, const char *input) {
 		}
 		debug = r_config_get_i (core->config, "cfg.debug");
 		flags |= R_PRINT_FLAGS_ADDRMOD | R_PRINT_FLAGS_HEADER;
-		r_print_set_flags (core->print, core->print->flags);
+		r_print_set_flags (core->print, flags);
 		scrseek = r_num_math (core->num,
 			r_config_get (core->config, "scr.seek"));
 		if (scrseek != 0LL) {
diff --git a/libr/egg/egg_lang.c b/libr/egg/egg_lang.c
index 61a9db3e4f3..48ad4370bc0 100644
--- a/libr/egg/egg_lang.c
+++ b/libr/egg/egg_lang.c
@@ -502,7 +502,6 @@ static void rcc_pushstr(REgg *egg, char *str, int filter) {
 					dotrim = 3;
 					break;
 				default:
-					dotrim = 0;
 					break;
 				}
 				if (dotrim) {
diff --git a/libr/magic/apprentice.c b/libr/magic/apprentice.c
index 406566d68cd..2d7a019218a 100644
--- a/libr/magic/apprentice.c
+++ b/libr/magic/apprentice.c
@@ -378,7 +378,6 @@ static size_t apprentice_r_magic_strength(const struct r_magic *m) {
 		val += 8 * MULT;
 		break;
 	default:
-		val = 0;
 		eprintf ("Bad type %d\n", m->type);
 		abort();
 	}
diff --git a/libr/socket/run.c b/libr/socket/run.c
index 029576caab9..ac6238ac11f 100644
--- a/libr/socket/run.c
+++ b/libr/socket/run.c
@@ -86,7 +86,7 @@ R_API bool r_run_parse(RRunProfile *pf, const char *profile) {
 		return false;
 	}
 	r_str_replace_char (str, '\r',0);
-	for (o = p = str; (o = strchr (p, '\n')); p = o) {
+	for (p = str; (o = strchr (p, '\n')); p = o) {
 		*o++ = 0;
 		r_run_parseline (pf, p);
 	}
diff --git a/libr/util/buf.c b/libr/util/buf.c
index 333a14aec09..e8eaa5dc518 100644
--- a/libr/util/buf.c
+++ b/libr/util/buf.c
@@ -177,7 +177,7 @@ static int r_buf_cpy(RBuffer *b, ut64 addr, ut8 *dst, const ut8 *src, int len, i
 
 static int r_buf_fcpy_at (RBuffer *b, ut64 addr, ut8 *buf, const char *fmt, int n, int write) {
 	ut64 len, check_len;
-	int i, j, k, tsize, m = 1;
+	int i, j, k, tsize = 2, m = 1;
 	bool bigendian = true;
 	r_return_val_if_fail (b && !b->empty, 0);
 
@@ -196,7 +196,6 @@ static int r_buf_fcpy_at (RBuffer *b, ut64 addr, ut8 *buf, const char *fmt, int
 	if (addr == UT64_MAX || addr > effective_size) {
 		return -1;
 	}
-	tsize = 2;
 	for (i = len = 0; i < n; i++) {
 		for (j = 0; fmt[j]; j++) {
 			switch (fmt[j]) {
diff --git a/libr/util/calc.c b/libr/util/calc.c
index 8eb141a3f45..d20b671f5f9 100644
--- a/libr/util/calc.c
+++ b/libr/util/calc.c
@@ -156,7 +156,6 @@ static RNumCalcValue prim(RNum *num, RNumCalc *nc, int get) {
 		}
 		return v;
 	case RNCNEG:
-		v = nc->number_value;
 		get_token (num, nc);
 		return Nneg (nc->number_value); //prim (num, nc, 1), 1);
 	case RNCINC:
diff --git a/shlr/grub/fs/jfs.c b/shlr/grub/fs/jfs.c
index 109cf92bb51..c19b1999a13 100644
--- a/shlr/grub/fs/jfs.c
+++ b/shlr/grub/fs/jfs.c
@@ -796,7 +796,7 @@ grub_jfs_dir (grub_device_t device, const char *path,
   if (hook)
   while (grub_jfs_getent (diro) != GRUB_ERR_OUT_OF_RANGE)
     {
-      struct grub_jfs_inode inode;
+      struct grub_jfs_inode inode = {0};
       struct grub_dirhook_info info;
       grub_memset (&info, 0, sizeof (info));
 
diff --git a/shlr/grub/fs/reiserfs.c b/shlr/grub/fs/reiserfs.c
index f371a92f38f..d30cf8772a1 100644
--- a/shlr/grub/fs/reiserfs.c
+++ b/shlr/grub/fs/reiserfs.c
@@ -752,7 +752,7 @@ grub_reiserfs_iterate_dir (grub_fshelp_node_t item,
   do
     {
       struct grub_reiserfs_directory_header *directory_headers;
-      struct grub_fshelp_node directory_item;
+      struct grub_fshelp_node directory_item = {0};
       grub_uint16_t entry_count, entry_number;
       struct grub_reiserfs_item_header *item_headers;
 
diff --git a/shlr/java/class.c b/shlr/java/class.c
index 23bf35c8eba..7ed313b2356 100644
--- a/shlr/java/class.c
+++ b/shlr/java/class.c
@@ -558,7 +558,6 @@ R_API char *r_bin_java_unmangle_method(const char *flags, const char *name, cons
 		ut32 offset = 0;
 		params_len += 1;
 		p_val_str = malloc (params_len);
-		params_idx = 0;
 		r_list_foreach (the_list, iter, str) {
 			if (offset != 0) {
 				offset += snprintf (p_val_str + offset, params_len - offset, ", %s", str);
@@ -1536,6 +1535,7 @@ R_API RBinJavaField *r_bin_java_read_next_field(RBinJavaObj *bin, const ut64 off
 			adv += attr->size;
 			if (adv + offset >= len) {
 				eprintf ("[X] r_bin_java: Error unable to parse remainder of classfile after Field Attribute: %d.\n", i);
+				r_bin_java_fmtype_free (field);
 				return NULL;
 			}
 		}
@@ -4156,7 +4156,7 @@ R_API RBinJavaStackMapFrameMetas *r_bin_java_determine_stack_frame_type(ut8 tag)
 	ut8 type_value = 0;
 	if (tag < 64) {
 		type_value = R_BIN_JAVA_STACK_FRAME_SAME;
-	} else if (63 < tag && tag < 128) {
+	} else if (tag < 128) {
 		type_value = R_BIN_JAVA_STACK_FRAME_SAME_LOCALS_1;
 	} else if (247 < tag && tag < 251) {
 		type_value = R_BIN_JAVA_STACK_FRAME_CHOP;
@@ -8511,13 +8511,11 @@ R_API ConstJavaValue *U(r_bin_java_resolve_to_const_value)(RBinJavaObj * BIN_OBJ
 		return result;
 	}
 	item = (RBinJavaCPTypeObj *) r_bin_java_get_item_from_bin_cp_list (BIN_OBJ, idx);
-	if (item) {
-		cp_name = ((RBinJavaCPTypeMetas *) item->metas->type_info)->name;
-		IFDBG eprintf("java_resolve Resolved: (%d) %s\n", idx, cp_name);
-	} else {
+	if (!item) {
 		return result;
 	}
 	cp_name = ((RBinJavaCPTypeMetas *) item->metas->type_info)->name;
+	IFDBG eprintf("java_resolve Resolved: (%d) %s\n", idx, cp_name);
 	if (strcmp (cp_name, "Class") == 0) {
 		item2 = (RBinJavaCPTypeObj *) r_bin_java_get_item_from_bin_cp_list (BIN_OBJ, idx);
 		// str = r_bin_java_get_name_from_bin_cp_list (BIN_OBJ, idx-1);
diff --git a/shlr/sdb/src/query.c b/shlr/sdb/src/query.c
index a2158c6ab89..42ca0029ab9 100644
--- a/shlr/sdb/src/query.c
+++ b/shlr/sdb/src/query.c
@@ -813,7 +813,6 @@ SDB_API char *sdb_querys (Sdb *r, char *buf, size_t len, const char *_cmd) {
 			bufset = 0;
 		}
 		cmd = next + 1;
-		encode = 0;
 		goto repeat;
 	}
 	if (eq) {
diff --git a/shlr/tcc/tccgen.c b/shlr/tcc/tccgen.c
index 1711bf745ba..9642565eba9 100644
--- a/shlr/tcc/tccgen.c
+++ b/shlr/tcc/tccgen.c
@@ -2431,7 +2431,7 @@ static void decl_designator(CType *type, unsigned long c,
 		}
 	} else {
 		if (type->t & VT_ARRAY) {
-			index = *cur_index;
+			index = cur_index ? *cur_index : 0;
 			type = pointed_type (type);
 			c += index * type_size (type, &align);
 		} else {
diff --git a/shlr/tcc/tccpp.c b/shlr/tcc/tccpp.c
index 72f28ecff5d..65e148c18b7 100644
--- a/shlr/tcc/tccpp.c
+++ b/shlr/tcc/tccpp.c
@@ -2914,7 +2914,7 @@ static int macro_subst_tok(TokenString *tok_str,
 				/* NOTE: non zero sa->t indicates VA_ARGS */
 				while ((parlevel > 0 ||
 					(tok != ')' &&
-					 (tok != ',' || sa->type.t))) &&
+					 (tok != ',' || (sa && sa->type.t)))) &&
 				       tok != -1) {
 					if (tok == '(') {
 						parlevel++;
